// StochKit input generated by the Bio-PEPA Workbench 0.8 "Brian Eno"

#include "ProblemDefinition.h"
#include <iostream>
#include <stdlib.h>
#include <math.h>


/* Constants for reaction identifiers */
#define ___infect 0
#define ___recover 1
#define ___REACTIONS 2


/* Constants for species identifiers */
#define ___S   0
#define    S   ___discreteSpeciesCount(0)
#define ___I   1
#define    I   ___discreteSpeciesCount(1)
#define ___R   2
#define    R   ___discreteSpeciesCount(2)
#define ___SPECIES 3

/* Reaction constants */
double
    k1 = 0.001,
    k2 = 1.0;


Matrix Stoichiometry ()
{
  Matrix ___stoichiometry(___SPECIES, ___REACTIONS, 0.0);

  /* S = (infect, 1) << S */
  ___stoichiometry(___S, ___infect) = -1;

  /* I = (infect, 1) >> I + (recover, 1) << I */
  ___stoichiometry(___I, ___infect) = +1;
  ___stoichiometry(___I, ___recover) = -1;

  /* R = (recover, 1) >> R */
  ___stoichiometry(___R, ___recover) = +1;

  return ___stoichiometry;
}

Vector Initialize ()
{

  /* Reaction constant initialisation */
  k1 = 0.001;
  k2 = 1.0;

  Vector ___initialSpeciesCount(___SPECIES, 0.0);
  ___initialSpeciesCount(___S) = 990;
  ___initialSpeciesCount(___I) = 10;
  ___initialSpeciesCount(___R) = 0;
  return ___initialSpeciesCount;
}

#include "KineticFunctions.cpp"

Vector Propensity (const Vector& ___discreteSpeciesCount)
{
  Vector ___propensity(___REACTIONS);

  /*      infect = [ k1 * S * I ] */
  ___propensity(___infect) = ( k1 * S * I );

  /*      recover = [ k2 * I ] */
  ___propensity(___recover) = ( k2 * I );
  return ___propensity;
}
